
#include <cstdio>  
#include <cstdlib>
#include <fstream>
using namespace std;  


#define CHARBITS		8

#define MAX_VERT		4000
#define MAX_PREAMBLE	10000
#define BOOL			char

#define edge(x,y) (bitmap[y/CHARBITS][x] & (1<<(y%CHARBITS)))

BOOL			Bitmap[MAX_VERT][MAX_VERT/CHARBITS];
unsigned char	bitmap[MAX_VERT/CHARBITS+1][MAX_VERT+1];
char			Preamble[MAX_PREAMBLE];
int				size_vert;//ʵʵĶĿ
int				size_edge;

BOOL        graph[MAX_VERT+1][MAX_VERT+1];


char masks[ 8 ] = { 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80 };

int get_params()//get vertex size
{
	char c, *tmp;
	char * pp = Preamble;
	int stop = 0;
	tmp = (char *)calloc(100, sizeof(char));

	size_vert = 0;

	while (!stop && (c = *pp++) != '\0')
	{
		switch (c)
		{
		case 'c':
			while ((c = *pp++) != '\n' && c != '\0');
			break;

		case 'p':
			sscanf(pp, "%s %d %d\n", tmp, &size_vert, &size_edge);
			stop = 1;
			break;

		default:
			break;
		}
	}

	free(tmp);

	if (size_vert == 0 || size_edge == 0)
		return 0;  /* error */
	else
		return 1;

}



BOOL get_edge(int i,int j )
{
	int byte, bit;
	char mask;
	int k;

	if (i<j) {
		k = i;
		i = j;
		j = k;
	}

	bit  = 7-(j & 0x00000007);
	byte = j >> 3;

	mask = masks[bit];
	return( (Bitmap[i][byte] & mask)==mask );
}

void readgraph(FILE *fp) 
{
	int i,j;
	int length = 0;//pre-string's length

	if (!fscanf(fp, "%d\n", &length))
	{ printf("ERROR: no preamble.\n"); exit(1); }

	fread(Preamble, 1, length, fp);
	Preamble[length] = '\0';

	if (!get_params())
	{ printf("ERROR: Corrupted preamble.\n"); exit(1); }

	if (size_vert >MAX_VERT) 
	{
		printf("Too many vertices! Recompile with %d > MAX_VERT \n",size_vert);
		exit(0);
	}

	for ( i = 0; i < size_vert && fread(Bitmap[i], 1, (int)((i + 8)/8), fp); i++ );

	fclose(fp);

	for (i = 0; i < size_vert; i++)
		for (j = 0; j < size_vert; j++)
			if (get_edge(i, j))
				bitmap[(j+1)/CHARBITS][i+1] |= (1 << ((j+1) % CHARBITS));

}


int main(int argc, char *argv[])
{
	int i,j;
	FILE *inputfile;
	if ((inputfile =  fopen(argv[1], "rb")) == NULL)
	{
		printf("Input graph does not exist");
		exit(1);
	}
	readgraph(inputfile);

	for(i=1;i<=size_vert;i++)
	{
		for (j=1;j<=size_vert;j++)
		{
			if(!edge(i,j))
				graph[i][j]=0;
			else 
				graph[i][j]=1;

		}
	}

	int clauseCount=0;
	fstream outf(argv[2],ios::out);
	outf<<"                                                  \n";
	for (i=1;i<=size_vert;i++)
		for (j=i+1;j<=size_vert;j++)
			if (!graph[i][j])//ͼ
			{
				outf<<"e "<<i<<' '<<j<<'\n';
				clauseCount++;
			}

	outf.seekg(0, ios::beg); 
	outf<<"p edge"<<' '<<size_vert<<' '<<clauseCount;
	outf.close();

	return 0;
}
